--- /dev/null	Sat Nov 16 11:18:13 2019
+++ new/usr/src/tools/smatch/src/validation/optim/and-or-mask3u.c	Sat Nov 16 11:18:13 2019
@@ -0,0 +1,25 @@
+#define W	3
+#define	S	8
+#define M	(W << S)
+
+static inline int fun(unsigned int x, unsigned int y)
+{
+	return ((x & M) | (y << S)) >> S;
+}
+
+int foo(unsigned int x, unsigned int y)
+{
+	return fun(x, y) & W;
+}
+
+/*
+ * check-name: and-or-mask3u
+ * check-command: test-linearize -Wno-decl $file
+ * check-known-to-fail
+ *
+ * check-output-ignore
+ * check-output-pattern(1): lsr\\.
+ * check-output-pattern(1): or\\.
+ * check-output-pattern(1): and\\.
+ * check-output-excludes: shl\\.
+ */
